_G = GLOBAL
local flag = false
local function GetKeyFromConfig(config)
    local key = GetModConfigData(config)
    return key and (type(key) == "number" and key or _G[key])
end

local function TurnOnNightVision(P)
	P.light = P.entity:AddLight()
	P.light:SetFalloff(0.5)
	P.light:SetIntensity(P.lightx)
	P.light:SetRadius(10^4)
	P.light:SetColour(255/255, 225/255, 255/255)
	P.light:Enable(true)
	P.components.talker:Say("夜视开启")
end

local function TurnOffNightVision(P)
	P.light = P.entity:AddLight()
	P.light:SetFalloff(0.5)
	P.light:SetIntensity(0)
	P.light:SetRadius(0)
	P.light:SetColour(255/255, 225/255, 255/255)
	P.light:Enable(false)
	P.components.talker:Say("夜视关闭")
end

_G.TheInput:AddKeyUpHandler(GetKeyFromConfig("light"), function ()
	if _G.ThePlayer == nil then return else
		local P = _G.ThePlayer
		flag = not flag
		if flag == true then
			P.lightx = P.lightx or 1 --初始化光强
			P:WatchWorldState("startday",TurnOffNightVision)
			P:WatchWorldState("startnight",TurnOnNightVision)
			if _G.TheWorld.state.isday or _G.TheWorld.state.isdusk then
				P.components.talker:Say("夜视将在夜晚启动")
			else
				P.components.talker:Say("现在是夜晚，启动夜视")
				TurnOnNightVision(P)
			end
		else
			if _G.TheWorld.state.isnight then
				TurnOffNightVision(P)
			end
			P:WatchWorldState("startnight",TurnOffNightVision)
			P.components.talker:Say("自动夜视关闭")
		end

	end
end)

_G.TheInput:AddKeyUpHandler(GetKeyFromConfig("light+"), function ()
	local P = _G.ThePlayer
	if not P then return end
	if not P.lightx then return end
	local lightnum = P.lightx + 0.1
	lightnum = lightnum >= 1 and 1 or lightnum
	P.lightx = lightnum or 1
	if P.lightk then
		P.light:SetIntensity(P.lightx)
	end
	P.components.talker:Say("夜视亮度: "..tostring(math.floor((P.lightx*10000))/100).."%")
end)

_G.TheInput:AddKeyUpHandler(GetKeyFromConfig("light-"), function ()
	local P = _G.ThePlayer
	if not P then return end
	if not P.lightx then return end
	local lightnum = P.lightx - 0.1
	lightnum = lightnum <= 0.001 and 0.001 or lightnum
	P.lightx = lightnum or 0.001
	if P.lightk then
		P.light:SetIntensity(P.lightx)
	end
	P.components.talker:Say("夜视亮度 "..tostring(math.floor((P.lightx*10000))/100).."%")
end)
